<?php

namespace Teknisa\SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class FctCopiaFormPreco {
    
    const NOME = "FCT_COPIA_FORM_PRECO";
    private $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure.
     * 
     * @param integer $nrFormPrecoServico
     * @param integer $nrorg
     * @param string  $operador
     * 
     */
    public function executar($nrFormPrecoServico, $nrorg, $operador) {
        
        $procedure = new StoredProcedure($this->connection, self::NOME);
        
        $procedure->addParam(new Param("P_NRFORMPRECOSERVICO", Param::PARAM_INPUT,  $nrFormPrecoServico, Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_NRORG",              Param::PARAM_INPUT,  $nrorg,              Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_OPERADOR",           Param::PARAM_INPUT,  $operador,           Param::PARAM_TYPE_STR));
        
        
        $procedure->execute();
    }
}

?>
