IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'STATUS_LOTECTB_APRCUSTOP'  and
            type   = 'TR'  and
            u.uid  = o.uid and
            u.name = USER)
   DROP TRIGGER STATUS_LOTECTB_APRCUSTOP
GO

CREATE TRIGGER STATUS_LOTECTB_APRCUSTOP ON APRCUSTOP
FOR DELETE
AS
DECLARE @V_CDLOTE            VARCHAR(20);
DECLARE @V_NRLANCLOTE        VARCHAR(6);
DECLARE @V_DTINICCTBL        DATETIME;
DECLARE @V_DTFINACCTBL       DATETIME;
DECLARE @V_DTORDPRODUCAO     DATETIME;
DECLARE @V_CDEMPRESA         VARCHAR(2);
DECLARE @OLD_CDFILIAL        VARCHAR(4);
DECLARE @OLD_NRORDPROD       VARCHAR(10);
DECLARE @V_IDTPGERACAOCONT   VARCHAR(01);
DECLARE @V_INSERTED          INT;
DECLARE @V_DELETED           INT;
DECLARE @NEW_IDSTATUSCTBOP   VARCHAR(01);
DECLARE @OLD_IDSTATUSCTBOP   VARCHAR(01);
BEGIN
   SELECT @V_IDTPGERACAOCONT = IDTPGERACAOCONT FROM PARAMCTBL;

   IF @V_IDTPGERACAOCONT <> 'O' BEGIN

      DECLARE C_APRCUSTOP CURSOR FOR
         SELECT CDFILIAL, NRORDPROD, IDSTATUSCTBOP
           FROM DELETED;
      OPEN C_APRCUSTOP;

      FETCH NEXT FROM C_APRCUSTOP INTO @OLD_CDFILIAL, @OLD_NRORDPROD, @OLD_IDSTATUSCTBOP;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SELECT @V_CDEMPRESA = CDEMPRESA
           FROM FILIAL
          WHERE CDFILIAL = @OLD_CDFILIAL;

         SELECT  @V_DTINICCTBL = DTINIINTCONTDFE, @V_DTFINACCTBL = DTFININTCONTDFE
           FROM CONTOPECTBL
          WHERE CDEMPRESA = @V_CDEMPRESA;

         SELECT @V_DTORDPRODUCAO = MAX(DTHRFIMREAOP)
           FROM ORDPRODUCAO
          WHERE CDFILIAL  = @OLD_CDFILIAL
            AND NRORDPROD = @OLD_NRORDPROD;

         SELECT @V_INSERTED = COUNT(*) FROM INSERTED;

         SELECT @V_DELETED = COUNT(*) FROM DELETED;


            IF ((@V_DELETED <> 0) AND (@V_INSERTED = 0)) BEGIN
               IF @V_DTORDPRODUCAO IS NULL BEGIN
                  SET @V_DTORDPRODUCAO = GETDATE();
               END;
               IF ((@V_DTORDPRODUCAO >= @V_DTINICCTBL) AND (@V_DTORDPRODUCAO <= @V_DTFINACCTBL)) BEGIN

                  DECLARE C_RELACAPRLANCLOT CURSOR FOR
                     SELECT MAX(CDLOTE)     AS CDLOTE,
                            MAX(NRLANCLOTE) AS NRLANCLOTE
                       FROM RELACAPRLANCLOT
                      WHERE CDFILIAL  = @OLD_CDFILIAL
                        AND NRORDPROD = @OLD_NRORDPROD;
                  OPEN C_RELACAPRLANCLOT;

                  FETCH NEXT FROM C_RELACAPRLANCLOT INTO @V_CDLOTE, @V_NRLANCLOTE;

                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     DELETE FROM RELACAPRLANCLOT
                      WHERE CDEMPRESA  = @V_CDEMPRESA
                        AND NRLANCLOTE = @V_NRLANCLOTE
                        AND CDFILIAL   = @OLD_CDFILIAL
                        AND NRORDPROD  = @OLD_NRORDPROD;

                     DELETE FROM LANCLOTE
                      WHERE CDEMPRESA  = @V_CDEMPRESA
                        AND CDLOTE     = @V_CDLOTE
                        AND NRLANCLOTE = @V_NRLANCLOTE;

                     EXEC REVERTE_LOTE @V_CDEMPRESA, @V_CDLOTE;

                     FETCH NEXT FROM C_RELACAPRLANCLOT INTO @V_CDLOTE, @V_NRLANCLOTE;
                  END;
                  CLOSE C_RELACAPRLANCLOT;
                  DEALLOCATE C_RELACAPRLANCLOT;
               END
               ELSE BEGIN
                  RAISERROR('Excluso no permitida, data fora do perodo contbil.', 16, 1);
               END;
            END;
      END;
      FETCH NEXT FROM C_APRCUSTOP INTO @OLD_CDFILIAL, @OLD_NRORDPROD, @OLD_IDSTATUSCTBOP;
   END;
   CLOSE C_APRCUSTOP;
   DEALLOCATE C_APRCUSTOP;
END;
GO

